//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Model/Data/SessionData.h
//! @brief     Defines struct SessionData
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2021
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_MODEL_DATA_SESSIONDATA_H
#define BORNAGAIN_GUI_MODEL_DATA_SESSIONDATA_H

#include "GUI/Model/Device/InstrumentLibrary.h"
#include <optional>

class ProjectDocument;

struct SessionData {
    SessionData();

    InstrumentLibrary instrumentLibrary;
    std::optional<ProjectDocument*> projectDocument;
};

extern SessionData* gSessionData; //!< global pointer to the single instance

#endif // BORNAGAIN_GUI_MODEL_DATA_SESSIONDATA_H
