//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Model/Model/ModelPath.h
//! @brief     Defines namespace GUI::Model::Path
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_MODEL_MODEL_MODELPATH_H
#define BORNAGAIN_GUI_MODEL_MODEL_MODELPATH_H

#include <QString>
#include <memory>
#include <vector>

class QModelIndex;
class SessionItem;
class SessionModel;

namespace GUI::Model::Path {

bool isValidItem(SessionModel* model, SessionItem* item, const QModelIndex& parent);

//! Returns ancestor of given modelType for given item.
//!
//! For example, returns corresponding jobItem owning ParameterItem via ParameterContainer.
SessionItem* ancestor(SessionItem* item, const QString& requiredModelType);

} // namespace GUI::Model::Path

#endif // BORNAGAIN_GUI_MODEL_MODEL_MODELPATH_H
