//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/View/FromDomain/GUIExamplesFactory.h
//! @brief     Defines class GUI::ExamplesFactory
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEW_FROMDOMAIN_GUIEXAMPLESFACTORY_H
#define BORNAGAIN_GUI_VIEW_FROMDOMAIN_GUIEXAMPLESFACTORY_H

#include <QString>

class MultiLayerItem;

//! Class that generates GUI model from
namespace GUI::ExamplesFactory {

bool isValidExampleName(const QString& name);

//! Create a multilayer item of the built-in example with the given internal name.
MultiLayerItem* createMultiLayerItem(const QString& name);

//! The internal example name, e.g. for creation with createMultiLayerItem.
QStringList exampleNames();

//! Returns human readable name and description
std::tuple<QString, QString> exampleInfo(const QString& name);

} // namespace GUI::ExamplesFactory

#endif // BORNAGAIN_GUI_VIEW_FROMDOMAIN_GUIEXAMPLESFACTORY_H
