//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/View/Import/RealDataMaskWidget.h
//! @brief     Defines class RealDataMaskWidget
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEW_IMPORT_REALDATAMASKWIDGET_H
#define BORNAGAIN_GUI_VIEW_IMPORT_REALDATAMASKWIDGET_H

#include "GUI/View/Common/SessionItemWidget.h"

class SessionItem;
class MaskEditor;
class IntensityDataItem;
class QAction;
class MaskContainerItem;

//! The RealDataMaskWidget class provides mask editing for RealDataItem on ImportDataView.

class RealDataMaskWidget : public SessionItemWidget {
    Q_OBJECT

public:
    RealDataMaskWidget(QWidget* parent = nullptr);

    QList<QAction*> actionList() override;

protected:
    void subscribeToItem() override;
    void unsubscribeFromItem() override;

private:
    IntensityDataItem* intensityDataItem();
    MaskContainerItem* maskContainer(IntensityDataItem* intensityData);

    MaskEditor* m_maskEditor;
};

#endif // BORNAGAIN_GUI_VIEW_IMPORT_REALDATAMASKWIDGET_H
