
// File: index.xml

// File: classCoherentFFSum.xml
%feature("docstring") CoherentFFSum "

Information about particle form factor and abundance.

C++ includes: CoherentFFSum.h
";

%feature("docstring")  CoherentFFSum::CoherentFFSum "CoherentFFSum::CoherentFFSum(double abundance, std::vector< std::shared_ptr< const SumDWBA >> terms)
";

%feature("docstring")  CoherentFFSum::summedFF "complex_t CoherentFFSum::summedFF(const DiffuseElement &ele) const
";

%feature("docstring")  CoherentFFSum::summedPolFF "SpinMatrix CoherentFFSum::summedPolFF(const DiffuseElement &ele) const
";

%feature("docstring")  CoherentFFSum::relativeAbundance "double CoherentFFSum::relativeAbundance() const
";

%feature("docstring")  CoherentFFSum::radialExtension "double CoherentFFSum::radialExtension() const
";


// File: classDecouplingApproximationStrategy.xml
%feature("docstring") DecouplingApproximationStrategy "

Strategy class to compute the total scattering from a particle layout in the decoupling approximation.

C++ includes: DecouplingApproximationStrategy.h
";

%feature("docstring")  DecouplingApproximationStrategy::DecouplingApproximationStrategy "DecouplingApproximationStrategy::DecouplingApproximationStrategy(const std::vector< std::unique_ptr< const CoherentFFSum >> &weighted_formfactors, const IInterference *iff, SimulationOptions sim_params, bool polarized)
";


// File: classDiffuseElement.xml
%feature("docstring") DiffuseElement "

Data stucture containing both input and output of a single detector cell.

C++ includes: DiffuseElement.h
";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(double wavelength, double alpha_i, double phi_i, std::unique_ptr< IPixel > pixel, const SpinMatrix &beam_polpair, const SpinMatrix &analyzer, bool isSpecular_, const Fluxes *fluxes_in=nullptr, const Fluxes *fluxes_out=nullptr)
";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(const DiffuseElement &)=delete
";

%feature("docstring")  DiffuseElement::DiffuseElement "DiffuseElement::DiffuseElement(DiffuseElement &&)
";

%feature("docstring")  DiffuseElement::~DiffuseElement "DiffuseElement::~DiffuseElement()
";

%feature("docstring")  DiffuseElement::setFluxes "void DiffuseElement::setFluxes(const Fluxes *fluxes_in, const Fluxes *fluxes_out)
";

%feature("docstring")  DiffuseElement::fluxIn "const IFlux * DiffuseElement::fluxIn(size_t i_layer) const
";

%feature("docstring")  DiffuseElement::fluxOut "const IFlux * DiffuseElement::fluxOut(size_t i_layer) const
";

%feature("docstring")  DiffuseElement::pointElement "DiffuseElement DiffuseElement::pointElement(double x, double y) const

Returns copy of this  DiffuseElement with k_f given by in-pixel coordinate x,y. 
";

%feature("docstring")  DiffuseElement::polarizationHandler "const PolMatrices& DiffuseElement::polarizationHandler() const

Returns assigned PolarizerPair. 
";

%feature("docstring")  DiffuseElement::wavelength "double DiffuseElement::wavelength() const
";

%feature("docstring")  DiffuseElement::alphaI "double DiffuseElement::alphaI() const
";

%feature("docstring")  DiffuseElement::getPhiI "double DiffuseElement::getPhiI() const
";

%feature("docstring")  DiffuseElement::alphaMean "double DiffuseElement::alphaMean() const
";

%feature("docstring")  DiffuseElement::getPhiMean "double DiffuseElement::getPhiMean() const
";

%feature("docstring")  DiffuseElement::setIntensity "void DiffuseElement::setIntensity(double intensity)
";

%feature("docstring")  DiffuseElement::addIntensity "void DiffuseElement::addIntensity(double intensity)
";

%feature("docstring")  DiffuseElement::intensity "double DiffuseElement::intensity() const
";

%feature("docstring")  DiffuseElement::getKi "R3 DiffuseElement::getKi() const
";

%feature("docstring")  DiffuseElement::meanKf "R3 DiffuseElement::meanKf() const
";

%feature("docstring")  DiffuseElement::meanQ "R3 DiffuseElement::meanQ() const
";

%feature("docstring")  DiffuseElement::getQ "R3 DiffuseElement::getQ(double x, double y) const

Returns scattering vector Q, with Kf determined from in-pixel coordinates x,y. In-pixel coordinates take values from 0 to 1. 
";

%feature("docstring")  DiffuseElement::integrationFactor "double DiffuseElement::integrationFactor(double x, double y) const
";

%feature("docstring")  DiffuseElement::solidAngle "double DiffuseElement::solidAngle() const
";

%feature("docstring")  DiffuseElement::alpha "double DiffuseElement::alpha(double x, double y) const
";

%feature("docstring")  DiffuseElement::getPhi "double DiffuseElement::getPhi(double x, double y) const
";

%feature("docstring")  DiffuseElement::wavevectorInfo "WavevectorInfo DiffuseElement::wavevectorInfo() const
";

%feature("docstring")  DiffuseElement::isSpecular "bool DiffuseElement::isSpecular() const

Tells if simulation element corresponds to a specular peak. 
";


// File: classIFlux.xml
%feature("docstring") IFlux "

Interface to access reflection/transmission coefficients. Realized by  ScalarFlux and  MatrixFlux.

C++ includes: IFlux.h
";

%feature("docstring")  IFlux::~IFlux "virtual IFlux::~IFlux()=default
";

%feature("docstring")  IFlux::T1plus "virtual Spinor IFlux::T1plus() const =0

The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  IFlux::R1plus "virtual Spinor IFlux::R1plus() const =0
";

%feature("docstring")  IFlux::T2plus "virtual Spinor IFlux::T2plus() const =0
";

%feature("docstring")  IFlux::R2plus "virtual Spinor IFlux::R2plus() const =0
";

%feature("docstring")  IFlux::T1min "virtual Spinor IFlux::T1min() const =0
";

%feature("docstring")  IFlux::R1min "virtual Spinor IFlux::R1min() const =0
";

%feature("docstring")  IFlux::T2min "virtual Spinor IFlux::T2min() const =0
";

%feature("docstring")  IFlux::R2min "virtual Spinor IFlux::R2min() const =0
";

%feature("docstring")  IFlux::getKz "virtual Spinor IFlux::getKz() const =0

Returns z-part of the two wavevector eigenmodes. 
";


// File: classIInterparticleStrategy.xml
%feature("docstring") IInterparticleStrategy "

Abstract base class of  DecouplingApproximationStrategy,  SSCAStrategy. Provides function 'evaluate' that computes the total scattering intensity from a decorated layer.

Instantiation of child classes takes place in LayoutStrategyBuilder::createStrategy, which is called from ParticleLayoutContribution::eval.

C++ includes: IInterparticleStrategy.h
";

%feature("docstring")  IInterparticleStrategy::IInterparticleStrategy "IInterparticleStrategy::IInterparticleStrategy(const std::vector< std::unique_ptr< const CoherentFFSum >> &weighted_formfactors, const SimulationOptions &sim_params, bool polarized)
";

%feature("docstring")  IInterparticleStrategy::~IInterparticleStrategy "IInterparticleStrategy::~IInterparticleStrategy()
";

%feature("docstring")  IInterparticleStrategy::evaluate "double IInterparticleStrategy::evaluate(const DiffuseElement &ele) const

Calculates the intensity for scalar particles/interactions. 
";


// File: classIntegratorMCMiser.xml
%feature("docstring") IntegratorMCMiser "";


// File: classIReParticle.xml
%feature("docstring") IReParticle "

Abstract base class for reprocessed particles.

Reprocessing is necessary to handle particles that cross material layers. These particles are divided into several.

C++ includes: IReParticle.h
";

%feature("docstring")  IReParticle::~IReParticle "IReParticle::~IReParticle() override=default
";

%feature("docstring")  IReParticle::clone "IReParticle* IReParticle::clone() const override=0
";

%feature("docstring")  IReParticle::setAmbientMaterial "virtual void IReParticle::setAmbientMaterial(const Material &)

Passes the material in which this particle is embedded. 
";

%feature("docstring")  IReParticle::theFF "virtual complex_t IReParticle::theFF(const WavevectorInfo &wavevectors) const =0

Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  IReParticle::radialExtension "virtual double IReParticle::radialExtension() const =0

Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IReParticle::bottomZ "virtual double IReParticle::bottomZ(const IRotation *rotation) const =0

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  IReParticle::topZ "virtual double IReParticle::topZ(const IRotation *rotation) const =0

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  IReParticle::thePolFF "SpinMatrix IReParticle::thePolFF(const WavevectorInfo &wavevectors) const

Returns scattering amplitude for matrix interactions. 
";

%feature("docstring")  IReParticle::volume "double IReParticle::volume() const

Returns the total volume of the particle of this form factor's shape. 
";


// File: classLayerFillLimits.xml
%feature("docstring") LayerFillLimits "

Helper class for the graded layer approximation. Generates limits for each layer, indicating the region of the layer (along z) that contains particle(s)

The constructor takes the bottom layer z-coordinates as parameter. This means that for N layers, only N-1 coordinates need to be passed (the last layer is assumed to be semi-infinite). 
";

%feature("docstring")  LayerFillLimits::LayerFillLimits "LayerFillLimits::LayerFillLimits(std::vector< double > layers_bottomz)
";

%feature("docstring")  LayerFillLimits::update "void LayerFillLimits::update(ZLimits particle_limits, double offset=0.0)

Particle limits are given in global coordinates. 
";

%feature("docstring")  LayerFillLimits::layerZLimits "std::vector< ZLimits > LayerFillLimits::layerZLimits() const

Returns the filled region limits for each layer (in local layer coordinates) 
";


// File: classMatrixFlux.xml
%feature("docstring") MatrixFlux "

Specular reflection and transmission coefficients in a layer in case of magnetic interactions between the scattered particle and the layer.

C++ includes: MatrixFlux.h
";

%feature("docstring")  MatrixFlux::MatrixFlux "MatrixFlux::MatrixFlux(double kz_sign, const Spinor &eigenvalues, const R3 &b, double magnetic_SLD)
";

%feature("docstring")  MatrixFlux::T1plus "Spinor MatrixFlux::T1plus() const override

The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  MatrixFlux::R1plus "Spinor MatrixFlux::R1plus() const override
";

%feature("docstring")  MatrixFlux::T2plus "Spinor MatrixFlux::T2plus() const override
";

%feature("docstring")  MatrixFlux::R2plus "Spinor MatrixFlux::R2plus() const override
";

%feature("docstring")  MatrixFlux::T1min "Spinor MatrixFlux::T1min() const override
";

%feature("docstring")  MatrixFlux::R1min "Spinor MatrixFlux::R1min() const override
";

%feature("docstring")  MatrixFlux::T2min "Spinor MatrixFlux::T2min() const override
";

%feature("docstring")  MatrixFlux::R2min "Spinor MatrixFlux::R2min() const override
";

%feature("docstring")  MatrixFlux::getKz "Spinor MatrixFlux::getKz() const override

Returns z-part of the two wavevector eigenmodes. 
";

%feature("docstring")  MatrixFlux::magneticSLD "double MatrixFlux::magneticSLD() const
";

%feature("docstring")  MatrixFlux::computeP "SpinMatrix MatrixFlux::computeP() const
";

%feature("docstring")  MatrixFlux::computeInverseP "SpinMatrix MatrixFlux::computeInverseP() const
";

%feature("docstring")  MatrixFlux::computeDeltaMatrix "SpinMatrix MatrixFlux::computeDeltaMatrix(double thickness)
";

%feature("docstring")  MatrixFlux::getReflectionMatrix "SpinMatrix MatrixFlux::getReflectionMatrix() const
";


// File: structParticleInSlice.xml
%feature("docstring") ParticleInSlice "

Struct that contains information on a sliced particle. This information is needed for evaluating the sliced form factor and the average of a material, used in the Fresnel calculations.

C++ includes: ParticleInSlice.h
";


// File: classProfileHelper.xml
%feature("docstring") ProfileHelper "

Object that can generate the material profile of a sample as a function of depth.

The generated profile contains the complex SLD for SLD materials and the parameters delta and beta for refractive index materials

C++ includes: ProfileHelper.h
";

%feature("docstring")  ProfileHelper::ProfileHelper "ProfileHelper::ProfileHelper(const SliceStack &stack)
";

%feature("docstring")  ProfileHelper::~ProfileHelper "ProfileHelper::~ProfileHelper()=default
";

%feature("docstring")  ProfileHelper::calculateProfile "std::vector< complex_t > ProfileHelper::calculateProfile(const std::vector< double > &z_values) const
";

%feature("docstring")  ProfileHelper::defaultLimits "std::pair< double, double > ProfileHelper::defaultLimits() const
";


// File: classReCompound.xml
%feature("docstring") ReCompound "

A reprocessed ParticleComposition.

C++ includes: ReCompound.h
";

%feature("docstring")  ReCompound::ReCompound "ReCompound::ReCompound()=default
";

%feature("docstring")  ReCompound::~ReCompound "ReCompound::~ReCompound() override
";

%feature("docstring")  ReCompound::clone "ReCompound * ReCompound::clone() const override
";

%feature("docstring")  ReCompound::radialExtension "double ReCompound::radialExtension() const override

Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReCompound::bottomZ "double ReCompound::bottomZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCompound::topZ "double ReCompound::topZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCompound::addFormFactor "void ReCompound::addFormFactor(const IReParticle &formfactor)
";

%feature("docstring")  ReCompound::setAmbientMaterial "void ReCompound::setAmbientMaterial(const Material &material) override

Passes the material in which this particle is embedded. 
";

%feature("docstring")  ReCompound::theFF "complex_t ReCompound::theFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReCompound::thePolFF "SpinMatrix ReCompound::thePolFF(const WavevectorInfo &wavevectors) const override

Calculates and returns a polarized form factor calculation in DWBA. 
";


// File: classReCoreShell.xml
%feature("docstring") ReCoreShell "

A reprocessed core shell particle.

C++ includes: ReCoreShell.h
";

%feature("docstring")  ReCoreShell::ReCoreShell "ReCoreShell::ReCoreShell(IReParticle *core, IReParticle *shell)
";

%feature("docstring")  ReCoreShell::~ReCoreShell "ReCoreShell::~ReCoreShell() override
";

%feature("docstring")  ReCoreShell::clone "ReCoreShell * ReCoreShell::clone() const override
";

%feature("docstring")  ReCoreShell::radialExtension "double ReCoreShell::radialExtension() const override

Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReCoreShell::bottomZ "double ReCoreShell::bottomZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCoreShell::topZ "double ReCoreShell::topZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReCoreShell::setAmbientMaterial "void ReCoreShell::setAmbientMaterial(const Material &material) override

Passes the material in which this particle is embedded. 
";

%feature("docstring")  ReCoreShell::theFF "complex_t ReCoreShell::theFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReCoreShell::thePolFF "SpinMatrix ReCoreShell::thePolFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for matrix interactions. 
";


// File: classreLayout.xml
%feature("docstring") reLayout "

Data structure that contains preprocessed data for a single layout.

If particles in the layout crossed the limits of the layer slices, these particles will be sliced themselves.

C++ includes: ReLayout.h
";

%feature("docstring")  reLayout::reLayout "reLayout::reLayout(bool polarized, double surface_density, std::vector< std::unique_ptr< const CoherentFFSum >> &&formfactors, const IInterference *iff, std::map< size_t, Admixtures > &&slice2admixtures)
";

%feature("docstring")  reLayout::reLayout "reLayout::reLayout(reLayout &&other)
";

%feature("docstring")  reLayout::~reLayout "reLayout::~reLayout()
";

%feature("docstring")  reLayout::surfaceDensity "double reLayout::surfaceDensity() const
";

%feature("docstring")  reLayout::formfactorList "const std::vector<std::unique_ptr<const CoherentFFSum> >& reLayout::formfactorList() const
";

%feature("docstring")  reLayout::interferenceFunction "const IInterference* reLayout::interferenceFunction() const
";

%feature("docstring")  reLayout::regionMap "const std::map<size_t, Admixtures>& reLayout::regionMap() const
";


// File: classReMesocrystal.xml
%feature("docstring") ReMesocrystal "

A reprocessed MesoCrystal.

C++ includes: ReMesocrystal.h
";

%feature("docstring")  ReMesocrystal::ReMesocrystal "ReMesocrystal::ReMesocrystal(const Lattice3D &lattice, const IReParticle &basis, const ReParticle &outer_shape, double position_variance=0.0)
";

%feature("docstring")  ReMesocrystal::~ReMesocrystal "ReMesocrystal::~ReMesocrystal() override
";

%feature("docstring")  ReMesocrystal::clone "ReMesocrystal* ReMesocrystal::clone() const override
";

%feature("docstring")  ReMesocrystal::setAmbientMaterial "void ReMesocrystal::setAmbientMaterial(const Material &material) override

Passes the material in which this particle is embedded. 
";

%feature("docstring")  ReMesocrystal::volume "double ReMesocrystal::volume() const override

Returns the total volume of the particle of this form factor's shape. 
";

%feature("docstring")  ReMesocrystal::radialExtension "double ReMesocrystal::radialExtension() const override

Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReMesocrystal::bottomZ "double ReMesocrystal::bottomZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReMesocrystal::topZ "double ReMesocrystal::topZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReMesocrystal::theFF "complex_t ReMesocrystal::theFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReMesocrystal::thePolFF "SpinMatrix ReMesocrystal::thePolFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for matrix interactions. 
";


// File: classReParticle.xml
%feature("docstring") ReParticle "

A reprocessed simple particle, with shape m_ff.

C++ includes: ReParticle.h
";

%feature("docstring")  ReParticle::ReParticle "ReParticle::ReParticle(const IFormFactor &ff)
";

%feature("docstring")  ReParticle::~ReParticle "ReParticle::~ReParticle() override
";

%feature("docstring")  ReParticle::clone "ReParticle * ReParticle::clone() const override
";

%feature("docstring")  ReParticle::setMaterial "void ReParticle::setMaterial(const Material &material)

Sets the material of the scatterer. 
";

%feature("docstring")  ReParticle::setAmbientMaterial "void ReParticle::setAmbientMaterial(const Material &ambient_material) override

Sets the ambient material. 
";

%feature("docstring")  ReParticle::setPosition "void ReParticle::setPosition(const R3 &position)
";

%feature("docstring")  ReParticle::setRotMatrix "void ReParticle::setRotMatrix(const RotMatrix &rotMatrix)
";

%feature("docstring")  ReParticle::theFF "complex_t ReParticle::theFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for complex wavevectors ki, kf. 
";

%feature("docstring")  ReParticle::thePolFF "SpinMatrix ReParticle::thePolFF(const WavevectorInfo &wavevectors) const override

Returns scattering amplitude for matrix interactions. 
";

%feature("docstring")  ReParticle::volume "double ReParticle::volume() const override

Returns the total volume of the particle of this form factor's shape. 
";

%feature("docstring")  ReParticle::radialExtension "double ReParticle::radialExtension() const override

Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  ReParticle::bottomZ "double ReParticle::bottomZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReParticle::topZ "double ReParticle::topZ(const IRotation *rotation) const override

Returns the z-coordinate of the lowest point in this shape after a given rotation. 
";

%feature("docstring")  ReParticle::formfactor_at_bottom "const IFormFactor * ReParticle::formfactor_at_bottom() const
";

%feature("docstring")  ReParticle::formfactor_at_bottom "complex_t ReParticle::formfactor_at_bottom(C3 q) const
";


// File: classreSample.xml
%feature("docstring") reSample "

Data structure that contains all the necessary data for scattering calculations.

If the usage of average materials is requested, layers and particles are sliced into multiple slices and the average material is calculated for each slice.

C++ includes: ReSample.h
";

%feature("docstring")  reSample::reSample "reSample::reSample(const reSample &)=delete
";

%feature("docstring")  reSample::~reSample "reSample::~reSample()
";

%feature("docstring")  reSample::numberOfSlices "size_t reSample::numberOfSlices() const
";

%feature("docstring")  reSample::averageSlices "const SliceStack & reSample::averageSlices() const
";

%feature("docstring")  reSample::avgeSlice "const Slice & reSample::avgeSlice(size_t i) const
";

%feature("docstring")  reSample::layouts "const std::vector< reLayout > & reSample::layouts() const
";

%feature("docstring")  reSample::sliceTopZ "double reSample::sliceTopZ(size_t i) const
";

%feature("docstring")  reSample::sliceBottomZ "double reSample::sliceBottomZ(size_t i) const
";

%feature("docstring")  reSample::containsMagneticMaterial "bool reSample::containsMagneticMaterial() const
";

%feature("docstring")  reSample::polarizing "bool reSample::polarizing() const

Contains magnetic material, or nonzero magnetic field. 
";

%feature("docstring")  reSample::hasRoughness "bool reSample::hasRoughness() const
";

%feature("docstring")  reSample::sample "const MultiLayer& reSample::sample() const
";

%feature("docstring")  reSample::fluxesIn "Fluxes reSample::fluxesIn(const R3 &k) const
";

%feature("docstring")  reSample::fluxesOut "Fluxes reSample::fluxesOut(const R3 &k) const
";

%feature("docstring")  reSample::crossCorrSpectralFun "double reSample::crossCorrSpectralFun(R3 kvec, size_t j, size_t k) const

Fourier transform of the correlation function of roughnesses between the interfaces. 
";


// File: classScalarFlux.xml
%feature("docstring") ScalarFlux "

Specular reflection and transmission coefficients in a layer in case of scalar interactions between the layers and the scattered particle.

C++ includes: ScalarFlux.h
";

%feature("docstring")  ScalarFlux::ScalarFlux "ScalarFlux::ScalarFlux(complex_t kz, Spinor TR)
";

%feature("docstring")  ScalarFlux::T1plus "Spinor ScalarFlux::T1plus() const override

The following functions return the transmitted and reflected amplitudes for different incoming beam polarizations and eigenmodes 
";

%feature("docstring")  ScalarFlux::R1plus "Spinor ScalarFlux::R1plus() const override
";

%feature("docstring")  ScalarFlux::T2plus "Spinor ScalarFlux::T2plus() const override
";

%feature("docstring")  ScalarFlux::R2plus "Spinor ScalarFlux::R2plus() const override
";

%feature("docstring")  ScalarFlux::T1min "Spinor ScalarFlux::T1min() const override
";

%feature("docstring")  ScalarFlux::R1min "Spinor ScalarFlux::R1min() const override
";

%feature("docstring")  ScalarFlux::T2min "Spinor ScalarFlux::T2min() const override
";

%feature("docstring")  ScalarFlux::R2min "Spinor ScalarFlux::R2min() const override
";

%feature("docstring")  ScalarFlux::getKz "Spinor ScalarFlux::getKz() const override

Returns z-part of the two wavevector eigenmodes. 
";

%feature("docstring")  ScalarFlux::getScalarT "complex_t ScalarFlux::getScalarT() const
";

%feature("docstring")  ScalarFlux::getScalarR "complex_t ScalarFlux::getScalarR() const
";

%feature("docstring")  ScalarFlux::getScalarKz "complex_t ScalarFlux::getScalarKz() const
";


// File: classSimulationOptions.xml
%feature("docstring") SimulationOptions "

Collect the different options for simulation.

SimulationOptions

C++ includes: SimulationOptions.h
";

%feature("docstring")  SimulationOptions::SimulationOptions "SimulationOptions::SimulationOptions()
";

%feature("docstring")  SimulationOptions::isIntegrate "bool SimulationOptions::isIntegrate() const
";

%feature("docstring")  SimulationOptions::getMcPoints "size_t SimulationOptions::getMcPoints() const
";

%feature("docstring")  SimulationOptions::setMonteCarloIntegration "void SimulationOptions::setMonteCarloIntegration(bool flag=true, size_t mc_points=50)

Enables/disables MonetCarlo integration.

Parameters:
-----------

flag: 
If true, MonteCarlo integration will be used, otherwise analytical calculations

mc_points: 
Number of points for MonteCarlo integrator 
";

%feature("docstring")  SimulationOptions::setNumberOfThreads "void SimulationOptions::setNumberOfThreads(int nthreads)

Sets number of threads to use during the simulation (0 - take the default value from the hardware) 
";

%feature("docstring")  SimulationOptions::getNumberOfThreads "unsigned SimulationOptions::getNumberOfThreads() const
";

%feature("docstring")  SimulationOptions::setNumberOfBatches "void SimulationOptions::setNumberOfBatches(int nbatches)

Sets number of batches to split. 
";

%feature("docstring")  SimulationOptions::getNumberOfBatches "unsigned SimulationOptions::getNumberOfBatches() const
";

%feature("docstring")  SimulationOptions::getCurrentBatch "unsigned SimulationOptions::getCurrentBatch() const
";

%feature("docstring")  SimulationOptions::setThreadInfo "void SimulationOptions::setThreadInfo(const ThreadInfo &thread_info)

Sets the batch and thread information to be used. 
";

%feature("docstring")  SimulationOptions::getHardwareConcurrency "unsigned SimulationOptions::getHardwareConcurrency() const
";

%feature("docstring")  SimulationOptions::setIncludeSpecular "void SimulationOptions::setIncludeSpecular(bool include_specular)
";

%feature("docstring")  SimulationOptions::includeSpecular "bool SimulationOptions::includeSpecular() const
";

%feature("docstring")  SimulationOptions::setUseAvgMaterials "void SimulationOptions::setUseAvgMaterials(bool use_avg_materials)
";

%feature("docstring")  SimulationOptions::useAvgMaterials "bool SimulationOptions::useAvgMaterials() const
";


// File: classSlice.xml
%feature("docstring") Slice "

Data structure containing the data of a single slice, for calculating the Fresnel coefficients.

C++ includes: Slice.h
";

%feature("docstring")  Slice::Slice "Slice::Slice(const ZLimits &zRange, Material material, const R3 &B_field, const LayerRoughness *roughness)
";

%feature("docstring")  Slice::Slice "Slice::Slice(const Slice &other)
";

%feature("docstring")  Slice::Slice "Slice::Slice(Slice &&other)
";

%feature("docstring")  Slice::~Slice "Slice::~Slice()
";

%feature("docstring")  Slice::setMaterial "void Slice::setMaterial(const Material &material)
";

%feature("docstring")  Slice::material "const Material & Slice::material() const
";

%feature("docstring")  Slice::zBottom "double Slice::zBottom() const
";

%feature("docstring")  Slice::zTop "double Slice::zTop() const
";

%feature("docstring")  Slice::zTopOr0 "double Slice::zTopOr0() const
";

%feature("docstring")  Slice::thicknessOr0 "double Slice::thicknessOr0() const
";

%feature("docstring")  Slice::topRoughness "const LayerRoughness * Slice::topRoughness() const
";

%feature("docstring")  Slice::scalarReducedPotential "complex_t Slice::scalarReducedPotential(R3 k, double n_ref) const

Return the potential term that is used in the one-dimensional Fresnel calculations. 
";

%feature("docstring")  Slice::polarizedReducedPotential "SpinMatrix Slice::polarizedReducedPotential(R3 k, double n_ref) const

Return the potential term that is used in the one-dimensional Fresnel calculations in the presence of magnetization 
";

%feature("docstring")  Slice::initBField "void Slice::initBField(R3 h_field, double h_z)

Initializes the magnetic B field from a given ambient field strength H. 
";

%feature("docstring")  Slice::bField "R3 Slice::bField() const
";

%feature("docstring")  Slice::invertBField "void Slice::invertBField()
";


// File: classSliceStack.xml
%feature("docstring") SliceStack "

A stack of  Slices.

C++ includes: SliceStack.h
";

%feature("docstring")  SliceStack::SliceStack "SliceStack::SliceStack(const RoughnessModel roughness_model)
";

%feature("docstring")  SliceStack::SliceStack "SliceStack::SliceStack(const SliceStack &other)
";

%feature("docstring")  SliceStack::addTopSlice "void SliceStack::addTopSlice(double zbottom, const Material &material)
";

%feature("docstring")  SliceStack::addSlice "void SliceStack::addSlice(double thickness, const Material &material, const LayerRoughness *roughness=nullptr)
";

%feature("docstring")  SliceStack::addNSlices "void SliceStack::addNSlices(size_t n, double thickness, const Material &material, const LayerRoughness *roughness=nullptr)

Adds n times the same slice to the stack. 
";

%feature("docstring")  SliceStack::setBField "SliceStack SliceStack::setBField(const R3 &externalField)
";

%feature("docstring")  SliceStack::containsMagneticMaterial "bool SliceStack::containsMagneticMaterial() const
";

%feature("docstring")  SliceStack::bottomRoughness "const LayerRoughness * SliceStack::bottomRoughness(size_t i_slice) const
";

%feature("docstring")  SliceStack::roughnessModel "RoughnessModel SliceStack::roughnessModel() const
";


// File: classSpecularElement.xml
%feature("docstring") SpecularElement "

Data stucture containing both input and output of a single image pixel for specular simulation.

C++ includes: SpecularElement.h
";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(double kz, const PolMatrices &polpair, bool computable)
";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(double wavelength, double alpha, const PolMatrices &polpair, bool computable)
";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(const SpecularElement &other)=delete
";

%feature("docstring")  SpecularElement::SpecularElement "SpecularElement::SpecularElement(SpecularElement &&other)
";

%feature("docstring")  SpecularElement::~SpecularElement "SpecularElement::~SpecularElement()
";

%feature("docstring")  SpecularElement::polarizationHandler "const PolMatrices& SpecularElement::polarizationHandler() const

Returns assigned PolarizerPair. 
";

%feature("docstring")  SpecularElement::intensity "double SpecularElement::intensity() const
";

%feature("docstring")  SpecularElement::setIntensity "void SpecularElement::setIntensity(double intensity)
";

%feature("docstring")  SpecularElement::isCalculated "bool SpecularElement::isCalculated() const

Returns calculation flag (if it's false, zero intensity is assigned to the element) 
";

%feature("docstring")  SpecularElement::produceKz "std::vector< complex_t > SpecularElement::produceKz(const SliceStack &slices)

Returns kz values for Abeles computation of reflection/transition coefficients. 
";


// File: classSSCAStrategy.xml
%feature("docstring") SSCAStrategy "

Strategy class to compute the total scattering from a particle layout in the size-spacing correlation approximation.

C++ includes: SSCAStrategy.h
";

%feature("docstring")  SSCAStrategy::SSCAStrategy "SSCAStrategy::SSCAStrategy(const std::vector< std::unique_ptr< const CoherentFFSum >> &weighted_formfactors, const InterferenceRadialParaCrystal *iff, SimulationOptions sim_params, bool polarized, double kappa)
";


// File: classSumDWBA.xml
%feature("docstring") SumDWBA "

Computes coherent sum of the four DWBA terms. Wraps an  IReParticle, and provides functions evaluate or evaluatePol. Used from  CoherentFFSum.

C++ includes: SumDWBA.h
";

%feature("docstring")  SumDWBA::SumDWBA "SumDWBA::SumDWBA(const IReParticle &ff, size_t i_layer)
";

%feature("docstring")  SumDWBA::SumDWBA "SumDWBA::SumDWBA(const IReParticle &ff)
";

%feature("docstring")  SumDWBA::~SumDWBA "SumDWBA::~SumDWBA()
";

%feature("docstring")  SumDWBA::ff "const IReParticle& SumDWBA::ff() const
";

%feature("docstring")  SumDWBA::iLayer "size_t SumDWBA::iLayer() const
";

%feature("docstring")  SumDWBA::coherentFF "complex_t SumDWBA::coherentFF(const DiffuseElement &ele) const

Returns the coherent sum of the four DWBA terms for scalar scattering. 
";

%feature("docstring")  SumDWBA::coherentPolFF "SpinMatrix SumDWBA::coherentPolFF(const DiffuseElement &ele) const

Returns the coherent sum of the four DWBA terms for polarized scattering. 
";


// File: classZLimits.xml
%feature("docstring") ZLimits "

An interval. Limits are of type double, and may be infinite. Used for the z-coordinate, especially when slicing form factors.

C++ includes: ZLimits.h
";

%feature("docstring")  ZLimits::ZLimits "ZLimits::ZLimits()
";

%feature("docstring")  ZLimits::ZLimits "ZLimits::ZLimits(double _min, double _max)
";

%feature("docstring")  ZLimits::isFinite "bool ZLimits::isFinite() const
";

%feature("docstring")  ZLimits::zBottom "double ZLimits::zBottom() const
";

%feature("docstring")  ZLimits::zTop "double ZLimits::zTop() const
";

%feature("docstring")  ZLimits::zTopOr0 "double ZLimits::zTopOr0() const
";

%feature("docstring")  ZLimits::thickness "double ZLimits::thickness() const
";

%feature("docstring")  ZLimits::thicknessOr0 "double ZLimits::thicknessOr0() const
";


// File: namespace_0d17.xml


// File: namespace_0d32.xml


// File: namespace_0d34.xml


// File: namespace_0d36.xml


// File: namespace_0d38.xml


// File: namespace_0d40.xml


// File: namespace_0d42.xml


// File: namespace_0d50.xml


// File: namespace_0d52.xml


// File: namespace_0d54.xml


// File: namespace_0d56.xml


// File: namespace_0d9.xml


// File: namespaceCompute.xml


// File: namespaceCompute_1_1Kz.xml
%feature("docstring")  Compute::Kz::computeReducedKz "std::vector< complex_t > Compute::Kz::computeReducedKz(const SliceStack &slices, R3 k)

Computes kz values from known k vector and slices with the following assumptions:
the beam penetrates fronting medium from a side

the wavelength is known for a distant point in vacuum (ref. index = 1)

the incident angle is known for the sample surface

This function is used in GISAS and off-spec computations mainly for back-compatibility reasons and should be replaced with computeKzFromRefIndices. 
";

%feature("docstring")  Compute::Kz::computeKzFromSLDs "std::vector< complex_t > Compute::Kz::computeKzFromSLDs(const SliceStack &slices, double kz)

Computes kz values from kz of the incoming beam known at a distant point in vacuum. It is assumed, that the beam penetrates fronting medium from a side. 
";

%feature("docstring")  Compute::Kz::computeKzFromRefIndices "std::vector< complex_t > Compute::Kz::computeKzFromRefIndices(const SliceStack &slices, R3 k)

Computes kz values from k-vector of the incoming beam known at a distant point in vacuum. It is assumed, that the beam penetrates fronting medium from a side. 
";


// File: namespaceCompute_1_1MagneticNevotCroceTransition.xml
%feature("docstring")  Compute::MagneticNevotCroceTransition::backwardsSubmatrices "std::pair< SpinMatrix, SpinMatrix > Compute::MagneticNevotCroceTransition::backwardsSubmatrices(const MatrixFlux &coeff_i, const MatrixFlux &coeff_i1, double sigma)
";


// File: namespaceCompute_1_1Slicing.xml
%feature("docstring")  Compute::Slicing::particleRegions "std::vector< ZLimits > Compute::Slicing::particleRegions(const MultiLayer &multilayer, bool use_slicing)

Calculate z-admixtures occupied by particles. 
";

%feature("docstring")  Compute::Slicing::createParticleInSlice "ParticleInSlice Compute::Slicing::createParticleInSlice(const IParticle *particle, const ZLimits &)
";

%feature("docstring")  Compute::Slicing::zSpan "ZLimits Compute::Slicing::zSpan(const IParticle *particle)
";


// File: namespaceCompute_1_1SpecularMagnetic.xml
%feature("docstring")  Compute::SpecularMagnetic::fluxes "Fluxes Compute::SpecularMagnetic::fluxes(const SliceStack &slices, const R3 &k, bool forward)

Computes refraction angle reflection/transmission coefficients for given sliced multilayer and wavevector k 
";

%feature("docstring")  Compute::SpecularMagnetic::topLayerR "SpinMatrix Compute::SpecularMagnetic::topLayerR(const SliceStack &slices, const std::vector< complex_t > &kzs, bool forward)

Computes the Fresnel R coefficient for the top layer only Introduced in order to speed up pure reflectivity computations 
";


// File: namespaceCompute_1_1SpecularScalar.xml
%feature("docstring")  Compute::SpecularScalar::fluxes "Fluxes Compute::SpecularScalar::fluxes(const SliceStack &slices, const R3 &k)

Computes refraction angles and transmission/reflection coefficients for given coherent wave propagation in a multilayer. 
";

%feature("docstring")  Compute::SpecularScalar::topLayerR "complex_t Compute::SpecularScalar::topLayerR(const SliceStack &slices, const std::vector< complex_t > &kz)

Computes the Fresnel R coefficient for the top layer only. Introduced in order to speed up pure reflectivity computations. 
";


// File: namespaceCompute_1_1TransitionMagneticTanh.xml
%feature("docstring")  Compute::TransitionMagneticTanh::backwardsSubmatrices "std::pair< SpinMatrix, SpinMatrix > Compute::TransitionMagneticTanh::backwardsSubmatrices(const MatrixFlux &coeff_i, const MatrixFlux &coeff_i1, double sigma)
";


// File: namespacestd.xml


// File: namespaceswigAPI.xml
%feature("docstring")  swigAPI::generateZValues "std::vector< double > swigAPI::generateZValues(int n_points, double z_min, double z_max)
";

%feature("docstring")  swigAPI::materialProfileSLD "std::vector< complex_t > swigAPI::materialProfileSLD(const MultiLayer &multilayer, int n_points, double z_min, double z_max)

Calculate average material profile for given multilayer. 
";

%feature("docstring")  swigAPI::defaultMaterialProfileLimits "std::pair< double, double > swigAPI::defaultMaterialProfileLimits(const MultiLayer &multilayer)

Get default z limits for generating a material profile. 
";


// File: CoherentFFSum_8cpp.xml


// File: CoherentFFSum_8h.xml


// File: SumDWBA_8cpp.xml


// File: SumDWBA_8h.xml


// File: DiffuseElement_8cpp.xml


// File: DiffuseElement_8h.xml


// File: SpecularElement_8cpp.xml


// File: SpecularElement_8h.xml


// File: IFlux_8h.xml


// File: MatrixFlux_8cpp.xml


// File: MatrixFlux_8h.xml


// File: ScalarFlux_8cpp.xml


// File: ScalarFlux_8h.xml


// File: DecouplingApproximationStrategy_8cpp.xml


// File: DecouplingApproximationStrategy_8h.xml


// File: IInterparticleStrategy_8cpp.xml


// File: IInterparticleStrategy_8h.xml


// File: SSCAStrategy_8cpp.xml


// File: SSCAStrategy_8h.xml


// File: SimulationOptions_8cpp.xml


// File: SimulationOptions_8h.xml


// File: IReParticle_8cpp.xml


// File: IReParticle_8h.xml


// File: ReCompound_8cpp.xml


// File: ReCompound_8h.xml


// File: ReCoreShell_8cpp.xml


// File: ReCoreShell_8h.xml


// File: ReMesocrystal_8cpp.xml


// File: ReMesocrystal_8h.xml


// File: ReParticle_8cpp.xml


// File: ReParticle_8h.xml


// File: ParticleInSlice_8h.xml


// File: ParticleRegions_8cpp.xml


// File: ParticleRegions_8h.xml


// File: ReLayout_8cpp.xml


// File: ReLayout_8h.xml


// File: ReSample_8cpp.xml


// File: ReSample_8h.xml


// File: Slicer_8cpp.xml


// File: Slicer_8h.xml


// File: KzComputation_8cpp.xml


// File: KzComputation_8h.xml


// File: ProfileHelper_8cpp.xml


// File: ProfileHelper_8h.xml


// File: Slice_8cpp.xml


// File: Slice_8h.xml


// File: SliceStack_8cpp.xml


// File: SliceStack_8h.xml


// File: ZLimits_8cpp.xml


// File: ZLimits_8h.xml


// File: ComputeFluxMagnetic_8cpp.xml


// File: ComputeFluxMagnetic_8h.xml


// File: ComputeFluxScalar_8cpp.xml


// File: ComputeFluxScalar_8h.xml


// File: TransitionMagneticNevot_8cpp.xml


// File: TransitionMagneticNevot_8h.xml


// File: TransitionMagneticTanh_8cpp.xml


// File: TransitionMagneticTanh_8h.xml


// File: MultiLayerFuncs_8cpp.xml


// File: MultiLayerFuncs_8h.xml


// File: dir_05914d190eb55651e85671c4f064dae1.xml


// File: dir_28bc1277e419364b011e46aeb2e8e251.xml


// File: dir_4ab1bbd9e8de6a7ddc078bbf4801b604.xml


// File: dir_f2e99fd688553c1021427f9f47ee68cc.xml


// File: dir_fc04159ec4b49a4525d9d1e735a03048.xml


// File: dir_31af213eb35073f0536a9d5d1d1efa3a.xml


// File: dir_8b8e406e0c078f14186b4022c818284f.xml


// File: dir_dd8f7bdc5adb03cd4741fd30e320356d.xml


// File: dir_5a6fad4f9f1572339acc49c35f6f6afa.xml


// File: dir_1581d6c09e9e4d82c1ed930bcfd40548.xml


// File: dir_3d5d340a448876c17068ec92885910e5.xml

