+++
title = "Find BornAgain"
weight = 10
+++

## Does Python find BornAgain?

After [installing]({{% relref "installation" %}}) BornAgain and Python,
the next step is to verify that the Python interpreter does find the module `bornagain`.
Note that the module name is in small caps only.

### From the command line

Use the command `python3` or `python` to launch the python interpreter.

The interpreter will print its version number to the terminal.
Make sure the version number starts with 3.
Python2 is no longer supported by BornAgain.

At the Python command prompt `>>>`, enter (with small caps)
```Python
import bornagain
```

Upon failure, you would get an error message like
```
>>> import bornagain as ba
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
ModuleNotFoundError: No module named 'bornagain'
```

Upon success, the interpreter will just show the next command prompt.
Enter
```Python
help('bornagain')
```
and scroll to the `DATA` section to see the major, minor, and patch number
of BornAgain.

### In Jupyter notebook

[more to come]

### In PyCharm IDE

[more to come]

### Proceed

From here, proceed to [running]({{% ref-py "start/run" %}})
an example script.
